Subject: ObjectContainerBuilder does not work for factory setups
Description

When configuring argument injection with a factory object and no name/classname the object container builder throws an exception
(after fixing the first symptom), which is:

Notice: Undefined index: name in /.../Object/Configuration/ConfigurationBuilder.php line 162

The line causing this reads as follows:

static protected function parseArgumentOfTypeObject($argumentName, $objectNameOrConfiguration,
$configurationSourceHint) {
    if (is_array($objectNameOrConfiguration)) {
        $objectName = $objectNameOrConfiguration['name'];

The Objects.yaml used:

F3\SwiftMailer\Mailer:
  arguments:
    1:
      object:
        factoryObjectName: F3\SwiftMailer\TransportFactory
        arguments:
          1:
            setting: SwiftMailer.transport.type
          2:
            setting: SwiftMailer.transport.options

Setting a classname there is not an option, as it would not be registered anyway. For property injection the case of a missing object
name is handled on ConfigurationBuilder by those lines in parsePropertyOfTypeObject:

if (isset($objectNameOrConfiguration['name'])) {
    $objectName = $objectNameOrConfiguration['name'];
    unset($objectNameOrConfiguration['name']);
} else {
    $objectName = NULL;
}

Adding this to parseArgumentOfTypeObject does the trick, but then we come to the error in the object builder:

Notice: Undefined index: in /.../Object/Container/ObjectContainerBuilder.php line 280

The line causing this reads as follows:

if ($argumentValue instanceof \F3\FLOW3\Object\Configuration\Configuration) {
    $argumentValueObjectName = $argumentValue->getObjectName();
    if ($this->objectConfigurations[$argumentValueObjectName]->getScope() ===
\F3\FLOW3\Object\Configuration\Configuration::SCOPE_PROTOTYPE) {
        $assignments[] = $assignmentPrologue . '$this->getPrototype(\'' . $argumentValueObjectName . '\', array(' .
$this->buildMethodParametersCode($argumentValue->getArguments()) . '))';

The bottom line is: using a factory with no object/class name does not work (anymore), neither for property nor argument injection.

Associated revisions
Revision 6db66049 - 2010-03-23 14:51 - Karsten Dambekalns

[+BUGFIX] FLOW3 (Configuration): getConfiguration() now returns settings for all packages if asked to do so, fixes #6967.
[+BUGFIX] FLOW3 (Object): Interfaces with no known implementation but a factory can be used now, fixes #6968, relates to #6928.
[~TASK] FLOW3 (Utility): In environment we no longer prohibit access to to $_SERVER, this makes use of third party code easier.

History
#1 - 2010-03-19 22:04 - Karsten Dambekalns
- Status changed from Accepted to New
- Assigned To deleted (Karsten Dambekalns)
- Start date deleted (2010-03-19)

Postponing as it can be gotten to work with a marker interface and some YAML magic. Needs to be discussed.

#2 - 2010-07-09 14:31 - Robert Lemke
- Status changed from New to Needs Feedback
- Priority changed from Must have to Should have
- Target version set to 1.0 alpha 11

#3 - 2010-08-18 15:56 - Karsten Dambekalns
- Status changed from Needs Feedback to Closed

Closing, as the problem has not surfaced again so far. And in cases like these, adding an interface to allow for type hints makes sense, so the
"workaround" actually looks like a good idea.
